Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.opensymphony.xwork2.conversion.impl
Class AnnotationXWorkConverter

    java.lang.Object
      com.opensymphony.xwork2.conversion.impl.DefaultTypeConverter
          com.opensymphony.xwork2.conversion.impl.XWorkConverter
              com.opensymphony.xwork2.conversion.impl.AnnotationXWorkConverter

All Implemented Interfaces:
  TypeConverter

Deprecated. Since XWork 2.0.4, the implementation of XWorkConverter handles the processing of annotations.

    @Deprecated
    public class AnnotationXWorkConverter

extends XWorkConverter

Type conversion is great for situations where you need to turn a String in to a more complex object. Because the web is type-agnostic (everything is a string in HTTP), XWork's type conversion features are very useful. For instance, if you were prompting a user to enter in coordinates in the form of a string (such as "3, 22"), you could have XWork do the conversion both from String to Point and from Point to String.

Using this "point" example, if your action (or another compound object in which you are setting properties on) has a corresponding ClassName-conversion.properties file, XWork will use the configured type converters for conversion to and from strings. So turning "3, 22" in to new Point(3, 22) is done by merely adding the following entry to ClassName-conversion.properties (Note that the PointConverter should impl the TypeConverter interface):

point = com.acme.PointConverter

Your type converter should be sure to check what class type it is being requested to convert. Because it is used for both to and from strings, you will need to split the conversion method in to two parts: one that turns Strings in to Points, and one that turns Points in to Strings.

After this is done, you can now reference your point (using <ww:property value="post"/> in JSP or ${point} in FreeMarker) and it will be printed as "3, 22" again. As such, if you submit this back to an action, it will be converted back to a Point once again.

In some situations you may wish to apply a type converter globally. This can be done by editing the file xwork-conversion.properties in the root of your class path (typically WEB-INF/classes) and providing a property in the form of the class name of the object you wish to convert on the left hand side and the class name of the type converter on the right hand side. For example, providing a type converter for all Point objects would mean adding the following entry:

com.acme.Point = com.acme.PointConverter

Type conversion should not be used as a substitute for i18n. It is not recommended to use this feature to print out properly formatted dates. Rather, you should use the i18n features of XWork (and consult the JavaDocs for JDK's MessageFormat object) to see how a properly formatted date should be displayed.

Any error that occurs during type conversion may or may not wish to be reported. For example, reporting that the input "abc" could not be converted to a number might be important. On the other hand, reporting that an empty string, "", cannot be converted to a number might not be important - especially in a web environment where it is hard to distinguish between a user not entering a value vs. entering a blank value.

By default, all conversion errors are reported using the generic i18n key xwork.default.invalid.fieldvalue, which you can override (the default text is Invalid field value for field "xxx", where xxx is the field name) in your global i18n resource bundle.

However, sometimes you may wish to override this message on a per-field basis. You can do this by adding an i18n key associated with just your action (Action.properties) using the pattern invalid.fieldvalue.xxx, where xxx is the field name.

It is important to know that none of these errors are actually reported directly. Rather, they are added to a map called conversionErrors in the ActionContext. There are several ways this map can then be accessed and the errors can be reported accordingly.

Author:
  Pat Lightbody, Rainer Hermanns
See Also:
  `XWorkConverter`

Field Summary

Fields inherited from class com.opensymphony.xwork2.conversion.impl.XWorkConverter
`CONVERSION_COLLECTION_PREFIX, CONVERSION_ERROR_PROPERTY_PREFIX, CONVERSION_PROPERTY_FULLNAME, LAST_BEAN_CLASS_ACCESSED, LAST_BEAN_PROPERTY_ACCESSED, MESSAGE_INDEX_BRACKET_PATTERN, MESSAGE_INDEX_PATTERN, messageIndexPattern, PERIOD, REPORT_CONVERSION_ERRORS`

Fields inherited from class com.opensymphony.xwork2.conversion.impl.DefaultTypeConverter
`MILLISECOND_FORMAT`

Fields inherited from interface com.opensymphony.xwork2.conversion.TypeConverter
`NO_CONVERSION_POSSIBLE, TYPE_CONVERTER_CONTEXT_KEY`

Constructor Summary
`AnnotationXWorkConverter()` Deprecated.

Method Summary

Methods inherited from class com.opensymphony.xwork2.conversion.impl.XWorkConverter
`addConverterMapping, buildConverterFilename, buildConverterMapping, convertValue, convertValue, getConversionErrorMessage, getConverter, handleConversionException, lookup, lookup, registerConverter, registerConverterNotFound, setConversionAnnotationProcessor, setConversionFileProcessor, setConversionPropertiesProcessor, setDefaultTypeConverter, setFileManagerFactory, setReloadingConfigs, setTypeConverterHolder`

Methods inherited from class com.opensymphony.xwork2.conversion.impl.DefaultTypeConverter
`bigDecValue, bigIntValue, booleanValue, convertValue, doubleValue, enumValue, getLocale, getTypeConverter, longValue, setContainer, stringValue, stringValue`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### AnnotationXWorkConverter

    public AnnotationXWorkConverter()

  Deprecated.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000–2017 Apache Software Foundation. All rights reserved.